#pragma once

#include "../base/CoreSegmentBase.h"

#include "ProviderSegment.h"

#include "../workingmemory/CoreSegment.h"


namespace armarx::armem::ltm
{

    /**
     * @brief Data of a core segment containing multiple provider segments.
     */
    class CoreSegment :
        public base::CoreSegmentBase<ProviderSegment, CoreSegment>
    {
        using Base = base::CoreSegmentBase<ProviderSegment, CoreSegment>;

    public:

        using Base::CoreSegmentBase;
        using Base::operator=;


        // Conversion
        wm::CoreSegment convert() const;

        // MongoDB connection
        void append(const wm::CoreSegment&);
    };

}
